/***************************************************************************/
/*                                                                         */
/*   Modul:      HTMLedit.C, c-source for HTMLedit                        */
/*                                                                         */
/*   Version:    0.099                                                     */
/*                                                                         */
/***************************************************************************/
#define VERSION   "0.128 - September 1, 1997"
#define BETA      "Internal Alpha"

#define INCL_DOS
#define INCL_WIN
#define INCL_GPI

#include <os2.h>
#include <webexwin.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <direct.h>

#include <stlibpmc.h>

#include "htmledit.h"
#include "dialog.h"

#define TESTBIT(i,b)    (((i)&(b)) != 0)

/*-------------------------------------------------------------------*/
MRESULT EXPENTRY ClientWndProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY SubClassedMLEProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
PFNWP DefaultMLEProc;
void EmphaseDrag (HWND hwnd, BOOL bFlag);

void RedrawClient(HWND hwnd);
void MouseSelect(HWND hwnd, MPARAM mp2);
void MouseClick(HWND hwnd, MPARAM mp2);

BOOL InsertText(char *szPre, char *szPost, int iFlag);
void SetStatusText(char *szText1, char *szText2, int iFlag);
void FixNLS(char *pbFileBlock, int iStrLen);

char *FileRead(char *szFileName, int *iRetFileSize);
BOOL FileWrite(char *szFileName, char *pbFileBlock, int iFileSize);

void LoadProfile (HWND hwnd);
void SaveProfile (HWND hwnd, int iFlag);

MRESULT EXPENTRY PrintDlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY SettingsNoteBookDlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY SettingsPage1DlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY SettingsPage2DlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY SettingsPage3DlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY SettingsPage4DlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);
MRESULT EXPENTRY SettingsPage5DlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2);

int KeyGetAscii(MPARAM mp1, MPARAM mp2);
int KeyGetVirtual(MPARAM mp1, MPARAM mp2);
BOOL KeyQueryShift(int iKey, MPARAM mp1);
void MLESetChange(HWND hwndMLE, BOOL bChange);
BOOL MLEGetChange(HWND hwndMLE);
int MLECursorRowPos (HWND hwndMLE);
int MLECursorColPos (HWND hwndMLE);
void SetWXFont(WXFONTSIZE wxFontSize);
/*-------------------------------------------------------------------*/


/* Puts all shared variables into
   the APPLICATION strucure. */

APPLICATION    app;

char           szDebug[512];


/*-----------------------------------------------------------------------------
   main: Entrypoint into this program.                               960209
-----------------------------------------------------------------------------*/
int main(int argc, char *argv[])
     {
     static char        szClassName [] = "HTMLedit 0.000";
     HMQ                hmq;
     QMSG               qmsg;
     ULONG              flFrameFlags  = FCF_STANDARD;

     char               *pcPointPos;
     int                rc;
     char               szMessage[_MAX_PATH];
     char               szTmpFile[_MAX_PATH];


     app.hab = WinInitialize(0);
     hmq = WinCreateMsgQueue(app.hab, 0);

     WinRegisterClass(app.hab, szClassName, ClientWndProc, CS_SIZEREDRAW | CS_CLIPCHILDREN, 0);

     /* Check for arguments. */
     switch (argc)
            {
            case 1: /* No URL */
                 szTmpFile[0] = '\0';
                 break;

            case 2: /* Get URL from argv[1] */
                 strcpy(szTmpFile, argv[1]);
                 break;

            default: /* Something is wrong. */
                 MessageBox (HWND_DESKTOP, MSGBOX_OK, "HTMLedit - FATAL ERROR", "Invalid number of parameters.");
                 return (FALSE);
                 break;
            }

     /* Create main window */
     app.hwndFrame = WinCreateStdWindow (HWND_DESKTOP, 0, (PVOID)&flFrameFlags, szClassName,
                                         "", WS_VISIBLE, 0, ID_RESOURCE, (PHWND) &app.hwndClient);

     /* Create status window */
     CreateStatusBar(app.hwndClient, &app.stsb, STATUS_TWO, STATUS_TEXT, STATUS_TEXT);
     SetStatusBarSplit(&app.stsb, 7);
     SetStatusBarFont(&app.stsb, "8.Helv");

     /* Create button bar */
     app.hwndButtonBar = CreateButtonBar(app.hwndClient, &app.bb, BBP_TOP, 15);

     SetButtonBarItem(&app.bb, 0, IDB_0, BBT_BITMAP, 100, 0, BBS_ENABLED, "New", "");
     SetButtonBarItem(&app.bb, 1, IDB_1, BBT_BITMAP, 101, 0, BBS_ENABLED, "Open", "");
     SetButtonBarItem(&app.bb, 2, IDB_2, BBT_BITMAP, 102, 0, BBS_ENABLED, "Save", "");
     SetButtonBarItem(&app.bb, 3, IDB_3, BBT_BITMAP, 103, 0, BBS_ENABLED, "Print", "");
     SetButtonBarItem(&app.bb, 4, 0, BBT_SPACE, 0, 0, 0, "", "");
     SetButtonBarItem(&app.bb, 5, IDB_4, BBT_BITMAP, 104, 0, BBS_ENABLED, "Cut", "");
     SetButtonBarItem(&app.bb, 6, IDB_5, BBT_BITMAP, 105, 0, BBS_ENABLED, "Copy", "");
     SetButtonBarItem(&app.bb, 7, IDB_6, BBT_BITMAP, 106, 0, BBS_ENABLED, "Paste", "");
     SetButtonBarItem(&app.bb, 8, 0, BBT_SPACE, 0, 0, 0, "", "");
     SetButtonBarItem(&app.bb, 9, IDB_9, BBT_BITMAP, 109, 0, BBS_ENABLED, "Maximize text", "");
     SetButtonBarItem(&app.bb, 10, IDB_11, BBT_BITMAP, 111, 0, BBS_ENABLED, "Show both", "");
     SetButtonBarItem(&app.bb, 11, IDB_10, BBT_BITMAP, 110, 0, BBS_ENABLED, "Maximize HTML", "");
     SetButtonBarItem(&app.bb, 12, IDB_8, BBT_BITMAP, 108, 0, BBS_ENABLED, "Update View", "");
     SetButtonBarItem(&app.bb, 13, 0, BBT_SPACE, 0, 0, 0, "", "");
     SetButtonBarItem(&app.bb, 14, IDB_7, BBT_BITMAP, 107, 0, BBS_ENABLED, "Font size", "");
     DrawButtonBar(&app.bb, 0);

     /* Create WebExplorer window */
     app.hwndWX = WinCreateWindow(app.hwndClient, WC_WXVIEW, NULL, WS_SYNCPAINT,
                                  0, 0, 0, 0, app.hwndClient, HWND_TOP, ID_WXWIN, NULL, NULL);

     /* Create Splitbar and ListBox */
     app.hwndSplitCanvas = CreateSplitBar(app.hwndClient, SBP_HORZ, &app.sb);

     app.hwndMLE = WinCreateWindow(app.hwndClient, WC_MLE, (char*) NULL,
                                   MLS_BORDER | MLS_HSCROLL | MLS_VSCROLL | WS_SYNCPAINT,
                                   0, 0, 0, 0, app.hwndClient, HWND_BOTTOM, ID_MLE, NULL, NULL);
     DefaultMLEProc = WinSubclassWindow(app.hwndMLE, (PFNWP) SubClassedMLEProc);

     /* Get profile filename */
     strcpy(szMessage, argv[0]);
     *(strrchr(szMessage, '.')) = '\0';
     sprintf(app.szIniFile, "%s.INI", szMessage);

     /* Load profile */
     LoadProfile(app.hwndClient);

     /* Load file */
     if (szTmpFile[0] != '\0')
        {
        }
     else
        {
        }

     RedrawClient(app.hwndClient);

     while (WinGetMsg (app.hab, &qmsg, (ULONG) NULL, 0L, 0L))
           WinDispatchMsg (app.hab, &qmsg) ;

     SaveProfile (app.hwndClient, 0);

     /* Kill of windows */
     WinDestroyWindow(app.hwndMLE);
     DestroySplitBar (&app.sb);

     WinDestroyWindow(app.hwndWX);
     DestroyButtonBar(&app.bb);
     WinDestroyWindow(app.hwndFrame) ;

     WinDestroyMsgQueue (hmq) ;
     WinTerminate (app.hab) ;
     return (TRUE);
     }


/*-----------------------------------------------------------------------------
   ClientWndProc: Handles messages for the (covered) client window.
-----------------------------------------------------------------------------*/
MRESULT EXPENTRY ClientWndProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {
     HPS                hps;
     char               szBuffer[256];
     char               szTag1[256], szTag2[256];
     char               szTmpFile[256], szMessage[256];
     int                rc, iCounter, iSelection;
     FILEDLG            pfdFiledlg;
     HWND               hwndFileDlg;
     char               *pbFileBlock;
     int                iFileLen;
     unsigned short     usVersion;


     switch (msg)
          {
          case WM_CREATE:
               memset(app.szFile, 0, _MAX_PATH);
               app.bChanged = FALSE;
               MLESetChange(app.hwndMLE, app.bChanged);
               app.iSplitSetting = 0;
               app.iwxFontSize = WXFONT_NORMAL;
               break;

          case WM_SIZE:
               RedrawClient(hwnd);
               break;

          case WM_PAINT:
               hps = WinBeginPaint (hwnd, NULLHANDLE, NULL) ;
               GpiErase (hps) ;
               WinEndPaint (hps) ;
               break ;

          case WM_SPLITBARMOVED:
               app.set.iSplitPos = LONGFROMMP(mp1);
               RedrawClient(hwnd);
               break;

          case WM_BUTTONBARSELECT:
               switch (SHORT1FROMMP(mp1))
                      {
                      case IDB_0:
                           WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_NEW), NULL);
                           break;

                      case IDB_1:
                           WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_LOAD), NULL);
                           break;

                      case IDB_2:
                           WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_SAVE), NULL);
                           break;

                      case IDB_3:
                           WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_PRINT), NULL);
                           break;

                      case IDB_4:
                           WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_CUT), NULL);
                           break;

                      case IDB_5:
                           WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_COPY), NULL);
                           break;

                      case IDB_6:
                           WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_PASTE), NULL);
                           break;

                      case IDB_7:
                           WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_FONTSIZE), NULL);
                           break;

                      case IDB_8:
                           WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_UPDATE), NULL);
                           break;

                      case IDB_9:
                           WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_MAXTEXT), NULL);
                           break;

                      case IDB_10:
                           WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_MAXHTML), NULL);
                           break;

                      case IDB_11:
                           WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_EQUAL), NULL);
                           break;

                      }
               break;


          case WM_COMMAND:
               switch (SHORT1FROMMP(mp1))
                      {
                      /**************************************************
                                   F I L E   -   M E N U
                      **************************************************/
                      case IDM_NEW:
                           if (MLEGetChange(app.hwndMLE) == TRUE)
                              {
                              sprintf(szBuffer, "Changes are not saved\nAre you sure ?");
                              if (MessageBox(hwnd, MSGBOX_NO, "HTMLedit - New file", szBuffer) == TRUE)
                                 {
                                 memset(app.szFile, 0, _MAX_PATH);
                                 memset(app.szName, 0, _MAX_PATH);
                                 app.bChanged = FALSE;
                                 MLESetChange(app.hwndMLE, app.bChanged);
                                 app.bNamed = FALSE;
                                 WinSetWindowText(app.hwndMLE, "");
                                 SetWindowTitle(hwnd, "HTMLedit - New design");
                                 }
                              }
                           else
                              {
                              memset(app.szFile, 0, _MAX_PATH);
                              memset(app.szName, 0, _MAX_PATH);
                              app.bChanged = FALSE;
                              MLESetChange(app.hwndMLE, app.bChanged);
                              app.bNamed = FALSE;
                              WinSetWindowText(app.hwndMLE, "");
                              SetWindowTitle(hwnd, "HTMLedit - New design");
                              }
                           break;

                      case IDM_LOAD:
                           if (MLEGetChange(app.hwndMLE) == TRUE)
                              {
                              sprintf(szBuffer, "Changes are not saved\nAre you sure ?");
                              if (MessageBox(hwnd, MSGBOX_NO, "HTMLedit - New file", szBuffer) == FALSE)
                                 {
                                 break;
                                 }
                              }
                           memset(&pfdFiledlg, 0, sizeof(FILEDLG));
                           pfdFiledlg.cbSize = sizeof(FILEDLG);
                           pfdFiledlg.fl = FDS_CENTER | FDS_OPEN_DIALOG;
                           pfdFiledlg.pszTitle = "HTMLedit - Select file";
                           sprintf(pfdFiledlg.szFullFile, "%s*.HTM*", app.set.szLoadFrom);

                           hwndFileDlg = WinFileDlg(HWND_DESKTOP, hwnd, &pfdFiledlg);
                           if (hwndFileDlg && (pfdFiledlg.lReturn == DID_OK))
                              {
                              strcpy(app.set.szLoadFrom, FileGetPath(pfdFiledlg.szFullFile));
                              if ( (pbFileBlock = FileRead(pfdFiledlg.szFullFile, &iFileLen)) != NULL)
                                 {
                                 WinSetWindowText(app.hwndMLE, "");
                                 if (MLEImport(app.hwndMLE, pbFileBlock, iFileLen) == TRUE)
                                    {
                                    FileSetDir(pfdFiledlg.szFullFile);
                                    strcpy(app.szFile, pfdFiledlg.szFullFile);
                                    strcpy(app.szName, pfdFiledlg.szFullFile);
                                    app.bChanged = FALSE;
                                    MLESetChange(app.hwndMLE, app.bChanged);
                                    app.bNamed = TRUE;
                                    sprintf(szBuffer, "HTMLedit - %s", app.szName);
                                    SetWindowTitle(hwnd, szBuffer);
                                    }
                                 else
                                    {
                                    sprintf(szBuffer, "File %s could not be opened", app.szFile);
                                    MessageBox(hwnd, MSGBOX_OK, "HTMLedit - ERROR", szBuffer);
                                    }
                                 free(pbFileBlock);
                                 }
                              else
                                 {
                                 sprintf(szBuffer, "File %s could not be opened", app.szFile);
                                 MessageBox(hwnd, MSGBOX_OK, "HTMLedit - ERROR", szBuffer);
                                 }
                              }
                           break;


                      case IDM_SAVE:
                           if (app.bNamed != TRUE)
                              WinPostMsg(hwnd, WM_COMMAND, MPFROMSHORT(IDM_SAVEAS), NULL);
                           else
                              {
                              iFileLen = MLEExportLength(app.hwndMLE);
                              pbFileBlock = (char *) calloc(iFileLen + 1, sizeof(char));
                              if (MLEExport(app.hwndMLE, pbFileBlock, iFileLen) == TRUE)
                                 {
                                 if (FileWrite(app.szFile, pbFileBlock, iFileLen) == TRUE)
                                    {
                                    app.bChanged = FALSE;
                                    MLESetChange(app.hwndMLE, app.bChanged);
                                    sprintf(szBuffer, "HTMLedit - %s", app.szName);
                                    SetWindowTitle(hwnd, szBuffer);
                                    }
                                 else
                                    {
                                    sprintf(szBuffer, "File %s could not be written to", app.szFile);
                                    MessageBox(hwnd, MSGBOX_OK, "HTMLedit - ERROR", szBuffer);
                                    }
                                 }
                              else
                                 {
                                 sprintf(szBuffer, "File %s could not be written to", app.szFile);
                                 MessageBox(hwnd, MSGBOX_OK, "HTMLedit - ERROR", szBuffer);
                                 }
                              free(pbFileBlock);
                              }
                           break;


                      case IDM_SAVEAS:
                           memset(&pfdFiledlg, 0, sizeof(FILEDLG));
                           pfdFiledlg.cbSize = sizeof(FILEDLG);
                           pfdFiledlg.fl = FDS_CENTER | FDS_SAVEAS_DIALOG | FDS_ENABLEFILELB;
                           pfdFiledlg.pszTitle = "HTMLedit - Save to file";
                           sprintf(pfdFiledlg.szFullFile, "%s*.HTM*", app.set.szSaveTo);

                           hwndFileDlg = WinFileDlg(HWND_DESKTOP, hwnd, &pfdFiledlg);
                           if (hwndFileDlg && (pfdFiledlg.lReturn == DID_OK))
                              {
                              strcpy(app.set.szSaveTo, FileGetPath(pfdFiledlg.szFullFile));
                              iFileLen = MLEExportLength(app.hwndMLE);
                              pbFileBlock = (char *) calloc(iFileLen + 1, sizeof(char));
                              if (MLEExport(app.hwndMLE, pbFileBlock, iFileLen) == TRUE)
                                 {
                                 if (FileWrite(pfdFiledlg.szFullFile, pbFileBlock, iFileLen) == TRUE)
                                    {
                                    FileSetDir(pfdFiledlg.szFullFile);
                                    strcpy(app.szFile, pfdFiledlg.szFullFile);
                                    strcpy(app.szName, pfdFiledlg.szFullFile);
                                    app.bChanged = FALSE;
                                    MLESetChange(app.hwndMLE, app.bChanged);
                                    sprintf(szBuffer, "HTMLedit - %s", app.szName);
                                    SetWindowTitle(hwnd, szBuffer);
                                    }
                                 else
                                    {
                                    sprintf(szBuffer, "File %s could not be written to", app.szFile);
                                    MessageBox(hwnd, MSGBOX_OK, "HTMLedit - ERROR", szBuffer);
                                    }
                                 }
                              else
                                 {
                                 sprintf(szBuffer, "File %s could not be written to", app.szFile);
                                 MessageBox(hwnd, MSGBOX_OK, "HTMLedit - ERROR", szBuffer);
                                 }
                              free(pbFileBlock);
                              }
                           break;


                      case IDM_PRINT:
                           rc = WinDlgBox(HWND_DESKTOP, hwnd, (PFNWP) PrintDlgProc, 0, DLG_PRINT, 0);
                           break;


                      /**************************************************
                                E D I T   -   M E N U
                      **************************************************/
                      case IDM_UNDO:
                           WinSendMsg(app.hwndMLE, MLM_UNDO, NULL, NULL);
                           break;


                      case IDM_CUT:
                           WinSendMsg(app.hwndMLE, MLM_CUT, NULL, NULL);
                           break;


                      case IDM_COPY:
                           WinSendMsg(app.hwndMLE, MLM_COPY, NULL, NULL);
                           break;


                      case IDM_PASTE:
                           WinSetFocus(HWND_DESKTOP, app.hwndMLE);
                           WinSendMsg(app.hwndMLE, MLM_PASTE, NULL, NULL);
                           break;

                      case IDM_CLEAR:
                           WinSendMsg(app.hwndMLE, MLM_CLEAR, NULL, NULL);
                           break;

                      case IDM_SELALL:
                           WinSendMsg(app.hwndMLE, MLM_SETSEL, MPFROMLONG(0L), MPFROMLONG(0xFFFF));
                           break;

                      case IDM_UPDATE:
                           _getcwd(szTmpFile, 256);
                           sprintf(szBuffer, "%s\\TEMPFILE.HTM", szTmpFile);
                           iFileLen = MLEExportLength(app.hwndMLE);
                           pbFileBlock = (char *) calloc(iFileLen + 1, sizeof(char));
                           if (MLEExport(app.hwndMLE, pbFileBlock, iFileLen) == TRUE)
                              {
                              /* FixNLS(pbFileBlock, iFileLen); */
                              if (FileWrite(szBuffer, pbFileBlock, iFileLen) != TRUE)
                                 {
                                 sprintf(szBuffer, "File %s could not be written to", szBuffer);
                                 MessageBox(hwnd, MSGBOX_OK, "HTMLedit - ERROR", szBuffer);
                                 }
                              }
                           else
                              {
                              sprintf(szBuffer, "File %s could not be written to", szBuffer);
                              MessageBox(hwnd, MSGBOX_OK, "HTMLedit - ERROR", szBuffer);
                              }
                           free(pbFileBlock);
                           WXViewLoad(app.hwndWX, szBuffer, WXLOAD_FORCERELOAD, NULL);
                           break;

                      case IDM_MAXTEXT:
                           app.iSplitSetting = 1;
                           RedrawClient(hwnd);
                           break;

                      case IDM_MAXHTML:
                           app.iSplitSetting = 2;
                           RedrawClient(hwnd);
                           break;

                      case IDM_EQUAL:
                           app.iSplitSetting = 0;
                           RedrawClient(hwnd);
                           break;


                      /**************************************************
                                   T A G S   -   M E N U
                      **************************************************/
                      case IDM_SKELETON:
                           sprintf(szTag1, "<html>\n<head>\n<title>Insert title here</title>\n</head>\n<body>\n\n</body>\n</html>\n");
                           InsertText(szTag1, "", 0);
                           break;

                      case IDM_HEAD:
                           sprintf(szTag1, "<head>\n");
                           sprintf(szTag2, "</head>\n");
                           InsertText(szTag1, szTag2, 0);
                           break;

                      case IDM_BODY:
                           sprintf(szTag1, "<body>\n");
                           sprintf(szTag2, "</body>\n");
                           InsertText(szTag1, szTag2, 0);
                           break;

                      case IDM_CENTER:
                           sprintf(szTag1, "<center>\n");
                           sprintf(szTag2, "</center>\n");
                           InsertText(szTag1, szTag2, 0);
                           break;


                      /**************************************************
                               S T Y L E S   -   M E N U
                      **************************************************/
                      case IDM_BOLD:
                           InsertText("<b>", "</b>", 0);
                           break;

                      case IDM_ITALIC:
                           InsertText("<i>", "</i>", 0);
                           break;

                      case IDM_BIG:
                           InsertText("<big>", "</big>", 0);
                           break;

                      case IDM_SMALL:
                           InsertText("<small>", "</small>", 0);
                           break;

                      case IDM_STRIKE:
                           InsertText("<strike>", "</strike>", 0);
                           break;

                      case IDM_STRONG:
                           InsertText("<strong>", "</strong>", 0);
                           break;

                      case IDM_SUB:
                           InsertText("<sub>", "</sub>", 0);
                           break;

                      case IDM_SUP:
                           InsertText("<sup>", "</sup>", 0);
                           break;

                      case IDM_TT:
                           InsertText("<tt>", "</tt>", 0);
                           break;

                      case IDM_U:
                           InsertText("<u>", "</u>", 0);
                           break;

                      case IDM_VAR:
                           InsertText("<var>", "</var>", 0);
                           break;

                      case IDM_BLOCKQUOTE:
                           InsertText("<blockquote>", "</blockquote>", 0);
                           break;

                      case IDM_CITE:
                           InsertText("<cite>", "</cite>", 0);
                           break;

                      case IDM_EM:
                           InsertText("<em>", "</em>", 0);
                           break;

                      case IDM_PRE:
                           InsertText("<pre>", "</pre>", 0);
                           break;

                      case IDM_SAMP:
                           InsertText("<samp>", "</samp>", 0);
                           break;

                      case IDM_KBD:
                           InsertText("<kbd>", "</kbd>", 0);
                           break;

                      case IDM_CODE:
                           InsertText("<code>", "</code>", 0);
                           break;

                      case IDM_H1:
                           InsertText("<h1 align=left>", "</h1>", 0);
                           break;

                      case IDM_H2:
                           InsertText("<h2 align=left>", "</h2>", 0);
                           break;

                      case IDM_H3:
                           InsertText("<h3 align=left>", "</h3>", 0);
                           break;

                      case IDM_H4:
                           InsertText("<h4 align=left>", "</h4>", 0);
                           break;

                      case IDM_H5:
                           InsertText("<h5 align=left>", "</h5>", 0);
                           break;

                      case IDM_H6:
                           InsertText("<h6 align=left>", "</h6>", 0);
                           break;

                      /**************************************************
                                   O P T I O N S  -   M E N U
                      **************************************************/
                      case IDM_FONTSIZE:

                           switch (app.iwxFontSize)
                                  {
                                  case WXFONT_SMALL:
                                       app.iwxFontSize = WXFONT_NORMAL;
                                       break;

                                  case WXFONT_NORMAL:
                                       app.iwxFontSize = WXFONT_LARGE;
                                       break;

                                  case WXFONT_LARGE:
                                       app.iwxFontSize = WXFONT_XLARGE;
                                       break;

                                  case WXFONT_XLARGE:
                                       app.iwxFontSize = WXFONT_SMALL;
                                       break;
                                  }
                           SetWXFont(app.iwxFontSize);
                           break;

                      case IDM_SAVESET:
                           WinQueryWindowPos(app.hwndFrame, &app.set.swp);
                           SaveProfile(hwnd, 0);
                           break;

                      /**************************************************
                                   H E L P   -   M E N U
                      **************************************************/
                      case IDM_ABOUT:
                           usVersion = WXViewQueryVersion();
                           sprintf(szBuffer, "HTMLedit %s\n%s\nPublic domain\n\nWEBEXWIN.DLL is version %d.%d\n",
                                   VERSION, BETA, HIBYTE(usVersion), LOBYTE(usVersion));
                           MessageBox(hwnd, MSGBOX_OK, "About HTMLedit", szBuffer);
                           break;

                      default:
                           return WinDefWindowProc(hwnd, msg, mp1, mp2);
                      }
               break;

          case WM_CONTROL:
               switch (SHORT1FROMMP(mp1))
                      {
                      case ID_MLE:
                           switch (SHORT2FROMMP(mp1))
                                  {
                                  case MLN_CHANGE:
                                       break;
                                  }
                           break;
                      }
               break;


          case WM_CLOSE:
          case WM_QUIT:
               if (MLEGetChange(app.hwndMLE) == TRUE)
                  {
                  sprintf(szBuffer, "Changes are not saved\nQuit anyway ?");
                  if (MessageBox(hwnd, MSGBOX_NO, "HTMLedit - Exit program", szBuffer) == FALSE)
                     return(0);
                  }
               return WinDefWindowProc(hwnd, msg, mp1, mp2);

          case WX_MOUSEMOVE:
               MouseSelect(hwnd, mp2);
               break;

          case WX_BUTTONCLICK:
               MouseClick(hwnd, mp2);
               break;

          case WX_LOADSTATUS:
               /* ShowWXLoad(hwnd, mp2); */
               break;

          case WX_MSGERROR:
               WXViewQueryMsgStr(app.hwndWX, mp2, szMessage, 256);
               MessageBox(hwnd, MSGBOX_OK, "HTMLedit - Information", szMessage);
               return (MRESULT)0;
               break;

          case WX_MSGINFO:
               WXViewQueryMsgStr(app.hwndWX, mp2, szMessage, 256);
               MessageBox(hwnd, MSGBOX_OK, "HTMLedit - Information", szMessage);
               return (MRESULT)0;
               break;

          default:
               return WinDefWindowProc (hwnd, msg, mp1, mp2);
          }
     return (FALSE);
     }


/*------------------------------------------------------------------------------
   RedrawClient: Redraws Client window.
-----------------------------------------------------------------------------*/
void RedrawClient(HWND hwnd)
     {
     ULONG              xpos, ypos, xsize, ysize, fontHeight, fontWidth;
     ULONG              ulQuarter, ulBorder;
     ULONG              bbHeight, statHeight, iSplitAt;
     RECTL              rclClient;


     WinQueryWindowRect(hwnd, &rclClient);

     bbHeight = SizeButtonBar(&app.bb, 0);
     statHeight = SizeStatusBar(&app.stsb, 0);

     if (app.set.iSplitPos == 0)
        app.set.iSplitPos = (rclClient.yTop) / 2;


     switch (app.iSplitSetting)
            {
            case 0:
                 iSplitAt = app.set.iSplitPos;
                 break;

            case 1:
                 iSplitAt = 0;
                 break;

            case 2:
                 iSplitAt = (rclClient.yTop - bbHeight);
                 break;
            }

     xpos = rclClient.xLeft;
     xsize = rclClient.xRight;
     ypos = rclClient.yBottom + statHeight;
     ysize = iSplitAt - ypos;
     if (ysize > 0)
        WinSetWindowPos(app.hwndWX, HWND_BOTTOM, xpos, ypos, xsize, ysize,
                        SWP_SIZE | SWP_MOVE | SWP_SHOW | SWP_ZORDER);
     else
        WinSetWindowPos(app.hwndWX, 0, 0, 0, 0, 0, SWP_HIDE | SWP_MOVE | SWP_SIZE);


     if (app.iSplitSetting == 0)
        {
        ulBorder = PositionSplitBar(&app.sb, 0, 0, app.set.iSplitPos);
        }
     else
        {
        ulBorder = 0;
        WinSetWindowPos(app.sb.hwndSplitBar, 0, 0, 0, 0, 0, SWP_HIDE | SWP_MOVE | SWP_SIZE);
        }

     xpos = rclClient.xLeft;
     xsize = rclClient.xRight;
     ypos = rclClient.yBottom + iSplitAt + ulBorder;
     ysize = (rclClient.yTop - bbHeight) - ypos;
     if (ysize > 0)
        WinSetWindowPos(app.hwndMLE, HWND_BOTTOM, xpos, ypos, xsize, ysize,
                        SWP_SIZE | SWP_MOVE | SWP_SHOW | SWP_ZORDER);
     else
        WinSetWindowPos(app.hwndMLE, 0, 0, 0, 0, 0, SWP_HIDE | SWP_MOVE | SWP_SIZE);

     }



/*------------------------------------------------------------------------------
   MouseSelect: When mouse moves over document.
-----------------------------------------------------------------------------*/
void MouseSelect(HWND hwnd, MPARAM mp2)
     {
     static int                 oldx, oldy;
     PWXMOUSEDATA               pwxMData;
     WXPOS                      wxPos;
     char                       szAnchor[256];


     pwxMData = (PWXMOUSEDATA)mp2;

     if (oldx == pwxMData->x && oldy == pwxMData->y)
        return;

     oldx = pwxMData->x;
     oldy = pwxMData->y;

     if (WXViewQueryPos(app.hwndWX, pwxMData->x, pwxMData->y, &wxPos ) == WX_SUCCESS)
        {
        if (WXViewQueryAnchor(app.hwndWX, &wxPos, szAnchor, 256) == WX_SUCCESS)
           SetStatusText(szAnchor, "", 1);
        else
           SetStatusText("", "", 1);
        }
     else
        SetStatusText("", "", 1);
     }


/*------------------------------------------------------------------------------
   MouseClick: When mouse is clicked in document.
-----------------------------------------------------------------------------*/
void MouseClick(HWND hwnd, MPARAM mp2)
     {
     PWXBUTTONDATA              pwxBData;
     WXPOS                      wxPos;
     char                       szAnchor[512];
     APIRET                     retErr;
     int                        iLen;



     pwxBData = (PWXBUTTONDATA)mp2;

     WinSetFocus(HWND_DESKTOP, app.hwndWX);

     if (WXViewQueryPos(app.hwndWX, pwxBData->x, pwxBData->y, &wxPos ) == WX_SUCCESS)
        {
        if (WXViewQueryAnchor(app.hwndWX, &wxPos, szAnchor, 512) == WX_SUCCESS)
           WXViewLoad(app.hwndWX, szAnchor, WXLOAD_ANCHOR, NULL);
        }
     else
        retErr = WXViewQueryLastError(app.hwndWX);
     }



/*------------------------------------------------------------------------------
   FixNLS: Fixes national language characters.
-----------------------------------------------------------------------------*/
void FixNLS(char *pbFileBlock, int iStrLen)
     {
     int        iCounter;


     for (iCounter = 0; iCounter < iStrLen; iCounter++)
         {
         switch (*(pbFileBlock + iCounter))
                {
                case '':
                     *(pbFileBlock + iCounter) = 229;

                case '':
                     *(pbFileBlock + iCounter) = 228;

                case '':
                     *(pbFileBlock + iCounter) = 246;

                case '':
                     *(pbFileBlock + iCounter) = 197;

                case '':
                     *(pbFileBlock + iCounter) = 196;

                case '':
                     *(pbFileBlock + iCounter) = 214;

                case '':
                     *(pbFileBlock + iCounter) = 220;

                case '':
                     *(pbFileBlock + iCounter) = 252;

                }
         }

     }


/*------------------------------------------------------------------------------
   InsertText: Inserts text into editor (using HTML rules).
-----------------------------------------------------------------------------*/
BOOL InsertText(char *szPre, char *szPost, int iFlag)
     {
     char               szBuffer[256];
     MRESULT            mrSelInfo;
     SHORT              sMinSel, sMaxSel;


     mrSelInfo = WinSendMsg(app.hwndMLE, MLM_QUERYSEL, MPFROMLONG(MLFQS_MINMAXSEL), NULL);
     sMinSel = SHORT1FROMMR(mrSelInfo);
     sMaxSel = SHORT2FROMMR(mrSelInfo);

     if (sMinSel != sMaxSel)
        {
        WinSendMsg(app.hwndMLE, MLM_SETSEL, MPFROMSHORT(sMinSel), MPFROMSHORT(sMinSel));
        WinSendMsg(app.hwndMLE, MLM_INSERT, MPFROMLONG(szPre), NULL);
        sMaxSel += strlen(szPre);
        WinSendMsg(app.hwndMLE, MLM_SETSEL, MPFROMSHORT(sMaxSel), MPFROMSHORT(sMaxSel));
        WinSendMsg(app.hwndMLE, MLM_INSERT, MPFROMLONG(szPost), NULL);
        }
     else
        {
        sprintf(szBuffer, "%s%s", szPre, szPost);
        WinSendMsg(app.hwndMLE, MLM_INSERT, MPFROMLONG(szBuffer), NULL);
        }
     return (TRUE);
     }



/*------------------------------------------------------------------------------
   SetStatusText: Sets specified font size.
-----------------------------------------------------------------------------*/
void SetStatusText(char *szText1, char *szText2, int iFlag)
     {
     static char        szLeft[256], szRight[256];

     switch (iFlag)
            {
            case 1:
                 strcpy(szLeft, szText1);
                 break;

            case 2:
                 strcpy(szRight, szText2);
                 break;

            case 3:
                 strcpy(szLeft, szText1);
                 strcpy(szRight, szText2);
                 break;
            }

     SetStatusBarText(&app.stsb, szLeft, szRight);
     }

/*------------------------------------------------------------------------------
   FileRead: Read whole file into a memory block.
-----------------------------------------------------------------------------*/
char *FileRead(char *szFileName, int *iRetFileSize)
     {
     FILE       *stream;
     int        iFileSize;
     char       *pbFileBlock;


     if ((stream = fopen(szFileName, "r")) != FALSE)
        {
        fseek(stream, 0L, SEEK_END);
        iFileSize = ftell(stream);
        pbFileBlock = (char *) calloc(iFileSize + 1, sizeof(char));
        fseek(stream, 0L, SEEK_SET);
        fread(pbFileBlock, 1, iFileSize, stream);
        fclose(stream);
        *(iRetFileSize) = iFileSize;
        return (pbFileBlock);
        }
     else
        *(iRetFileSize) = 0;
        return (NULL);
     }


/*------------------------------------------------------------------------------
   FileWrite: Write memory block to a (new) file.
-----------------------------------------------------------------------------*/
BOOL FileWrite(char *szFileName, char *pbFileBlock, int iFileSize)
     {
     FILE       *stream;


     if ((stream = fopen(szFileName, "wb")) != FALSE)
        {
        fwrite(pbFileBlock, 1, iFileSize, stream);
        fclose(stream);
        return(TRUE);
        }
     else
        return(FALSE);
     }


/*-----------------------------------------------------------------------------
   SubClassedMLEProc: Subclassed version of the standard Listbox procedure.
-----------------------------------------------------------------------------*/
MRESULT EXPENTRY SubClassedMLEProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {
     HWND               hwndMenu;
     POINTL             ptl;
     ULONG              flOptions;

     ULONG              cbBuffer;
     PDRAGITEM          pditem;
     PDRAGINFO          pdinfo;
     char               szPath[128], szFile[128], szFullFile[256];
     char               szBuffer[256];

     PDRAGINFO          pSourceDraginfo;
     HSTR               hstrType, hstrRMF, hstrContainer;

     DRAGITEM           Dragitem;
     CHAR               szContainer[CCHMAXPATH];
     DRAGIMAGE          dimg;

     int                iLbItem, iCounter, iItems;

     FILE               *stream;
     int                iFileSize;
     char               *szFileText;

     PPRINTDEST         pprintDest;


     switch (msg)
            {

            case WM_CHAR:
                 if (KeyQueryShift(KC_CTRL, mp1) == TRUE)
                    {
                    switch (KeyGetAscii(mp1, mp2))
                           {
                           case 13:
                                InsertText("<br>\n", "", 0);
                                return (MRESULT) TRUE;

                           case 'P':
                           case 'p':
                                InsertText("<p align=left>\n", "", 0);
                                return (MRESULT) TRUE;

                           default:
                                break;
                           }
                    }
                 else
                    {
                    switch (KeyGetAscii(mp1, mp2))
                           {
                           case '':
                                InsertText("&aring;", "", 0);
                                return (MRESULT) TRUE;

                           case '':
                                InsertText("&auml;", "", 0);
                                return (MRESULT) TRUE;

                           case '':
                                InsertText("&ouml;", "", 0);
                                return (MRESULT) TRUE;

                           case '':
                                InsertText("&Aring;", "", 0);
                                return (MRESULT) TRUE;

                           case '':
                                InsertText("&Auml;", "", 0);
                                return (MRESULT) TRUE;

                           case '':
                                InsertText("&Ouml;", "", 0);
                                return (MRESULT) TRUE;

                           default:
                                break;
                           }
                    }

                 return ((MRESULT) DefaultMLEProc(hwnd, msg, mp1, mp2));


            case DM_DRAGOVER:
                 EmphaseDrag (hwnd, TRUE);

                 pdinfo = (PDRAGINFO)mp1;
                 DrgAccessDraginfo(pdinfo);
                 pditem = DrgQueryDragitemPtr(pdinfo, 0);
                 if (DrgVerifyRMF(pditem, "DRM_OS2FILE", "DRF_TEXT"))
                    {
                    DrgFreeDraginfo(pdinfo);
                    return((MRESULT) MPFROM2SHORT(DOR_DROP, DO_COPY));
                    }
                 else
                    {
                    DrgFreeDraginfo(pdinfo);
                    return((MRESULT) MPFROM2SHORT(DOR_NEVERDROP, 0));
                    }
                 break;


            case DM_DRAGLEAVE:
                 EmphaseDrag (hwnd, FALSE);
                 break;


            case DM_DROP:
                 EmphaseDrag (hwnd, FALSE);

                 pdinfo = (PDRAGINFO)mp1;
                 DrgAccessDraginfo(pdinfo);

                 iItems = DrgQueryDragitemCount(pdinfo);

                 for (iCounter = 0; iCounter < iItems; iCounter++)
                     {
                     pditem = DrgQueryDragitemPtr(pdinfo, iCounter);
                     DrgQueryStrName(pditem->hstrContainerName, 128, szPath);
                     DrgQueryStrName(pditem->hstrSourceName, 128, szFile);
                     sprintf(szFullFile, "%s%s", szPath, szFile);
                     }

                 DrgFreeDraginfo(pdinfo);
                 break;


            case WM_CONTEXTMENU:
/********************************************
                 WinQueryPointerPos(HWND_DESKTOP, &ptl);
                 WinMapWindowPoints(HWND_DESKTOP, app.hwndClient, &ptl, 1);
                 hwndMenu = WinLoadMenu(app.hwndClient, NULLHANDLE, ID_MENUQUICKLIST);
                 flOptions = PU_KEYBOARD | PU_MOUSEBUTTON1 | PU_HCONSTRAIN | PU_VCONSTRAIN;
                 WinPopupMenu(app.hwndClient, app.hwndClient, hwndMenu, ptl.x, ptl.y, 0, (USHORT) flOptions);
********************************************/
                 break;


            case WM_BEGINDRAG:

                    pSourceDraginfo = DrgAllocDraginfo(1);

                    hstrType  = DrgAddStrHandle(DRT_UNKNOWN);
                    hstrRMF   = DrgAddStrHandle("(DRM_OS2FILE,DRM_PRINT,DRM_DISCARD)x(DRF_UNKNOWN)");

                    sprintf(szContainer, "%s", GetExeDir());
                    hstrContainer = DrgAddStrHandle(szContainer);

                    Dragitem.hwndItem          = app.hwndMLE;
                    Dragitem.hstrType          = hstrType;

                    Dragitem.hstrRMF           = hstrRMF;
                    Dragitem.hstrContainerName = hstrContainer;
                    Dragitem.fsControl         = 0;
                    Dragitem.fsSupportedOps    = DO_COPYABLE | DO_MOVEABLE;
                    Dragitem.hstrSourceName    = DrgAddStrHandle("REMOVE.TMP");
                    Dragitem.hstrTargetName    = DrgAddStrHandle(szBuffer);
                    Dragitem.ulItemID          = 1;

                    DrgSetDragitem(pSourceDraginfo, &Dragitem, sizeof(DRAGITEM), 0);

                    dimg.cb       = sizeof (DRAGIMAGE);
                    dimg.hImage   = WinQuerySysPointer (HWND_DESKTOP, SPTR_FILE, FALSE);
                    dimg.fl       = DRG_ICON;
                    dimg.cxOffset = 0;
                    dimg.cyOffset = 0;

                    pSourceDraginfo->hwndSource = app.hwndFrame;

                    DrgDrag(app.hwndFrame, pSourceDraginfo, &dimg, 1L, VK_BUTTON2, NULL);

                    return (MRESULT)TRUE;


            default:
                 return ((MRESULT) DefaultMLEProc(hwnd, msg, mp1, mp2));
            }
     return (FALSE);
     }


/*-----------------------------------------------------------------------------
   EmphaseDrag: Emphases drop window.
-----------------------------------------------------------------------------*/
void EmphaseDrag (HWND hwnd, BOOL bFlag)
     {
     HPS                hps;
     POINTL             ptl;
     RECTL              rcl;
     long               lColor;
     static BOOL        bDraw = TRUE;


     if (bFlag == TRUE && bDraw == FALSE)
        return;

     WinQueryWindowRect(hwnd, &rcl);

     hps = DrgGetPS(hwnd);

     if (bFlag == TRUE)
        bDraw = FALSE;
     else
        bDraw = TRUE;

     ptl.x = ptl.y = 5;
     GpiMove(hps, &ptl);

     ptl.x = rcl.xRight - rcl.xLeft - 5;
     ptl.y = rcl.yTop - rcl.yBottom - 5;

     GpiSetColor(hps, CLR_RED);
     GpiSetMix(hps, FM_XOR);
     GpiSetBackMix(hps, BM_LEAVEALONE);

     GpiBox(hps, DRO_OUTLINE, &ptl, 0L, 0L);
     DrgReleasePS(hps);
     }


/*-----------------------------------------------------------------------------
   LoadProfile: Loads the application settings from its profile file.
-----------------------------------------------------------------------------*/
void LoadProfile (HWND hwnd)
     {
     char               szBuffer[80];
     ULONG              ulAttrFound, ulColorValue;
     char               szFileName[CCHMAXPATH];
     int                iCounter;

     WXDISPLAYOPTS      wxDisplayOpts;



     strcpy(szFileName, app.szIniFile);

     if ( ReadProfile (app.hab, szFileName, "HTMLedit", "Setting", (char*)&app.set, sizeof(SETTINGS)) )
        {
        WinSetWindowPos(app.hwndFrame, HWND_TOP, app.set.swp.x, app.set.swp.y,
                        app.set.swp.cx, app.set.swp.cy, SWP_MOVE | SWP_SIZE | SWP_SHOW);

        WXViewQueryDisplayOpts(app.hwndWX, &wxDisplayOpts, sizeof(WXDISPLAYOPTS));
        wxDisplayOpts.wxFontSize  = WXFONT_NORMAL;
        sprintf(wxDisplayOpts.szFontName, "Helv");
        wxDisplayOpts.bInlineGraphics = TRUE;
        WXViewSetDisplayOpts(app.hwndWX, &wxDisplayOpts, sizeof(WXDISPLAYOPTS));
        }
     else
        {
        /* Save current window position */
        WinSetWindowPos(app.hwndFrame, HWND_TOP, 0, 0, 0, 0, SWP_SHOW);
        WinQueryWindowPos(app.hwndFrame, &app.set.swp);


        WXViewQueryDisplayOpts(app.hwndWX, &wxDisplayOpts, sizeof(WXDISPLAYOPTS));

        wxDisplayOpts.wxFontSize  = WXFONT_NORMAL;
        sprintf(wxDisplayOpts.szFontName, "Helv");
        wxDisplayOpts.bInlineGraphics = TRUE;

        WXViewSetDisplayOpts(app.hwndWX, &wxDisplayOpts, sizeof(WXDISPLAYOPTS));

        /* Save this profile */
        SaveProfile (hwnd, TRUE);
        }
     }


/*-----------------------------------------------------------------------------
   SaveProfile: Saves the application settings into its profile file.
-----------------------------------------------------------------------------*/
void SaveProfile (HWND hwnd, int iFlag)
     {
     char               szFileName[CCHMAXPATH];
     WXDISPLAYOPTS      wxDispOpts;


     strcpy(szFileName, app.szIniFile);

     WriteProfile (app.hab, szFileName, "HTMLedit", "Setting", (char*)&app.set, sizeof(SETTINGS));
     }


/*------------------------------------------------------------------------------
   PrintDlgProc: Handles messages for the DLG_PRINT dialog.
-----------------------------------------------------------------------------*/
MRESULT EXPENTRY PrintDlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {
     static PPMQUEUEINFO        pPmQueueArray;
     int                        iCounter, iDefault, iAntal;
     int                        iSelected, iCopies;


     switch (msg)
            {
            case WM_INITDLG:

                 iAntal = PrtQueryQueues();

                 if (iAntal < 1)
                    {
                    WinAlarm(HWND_DESKTOP, WA_ERROR);
                    MessageBox(hwnd, MSGBOX_OK, "HTMLedit - Print","No printers found !\nCannot print.");
                    WinDismissDlg(hwnd, FALSE);
                    }

                 pPmQueueArray = malloc(iAntal * sizeof(PMQUEUEINFO));
                 if (PrtGetQueues(pPmQueueArray, iAntal) == FALSE)
                    {
                    WinAlarm(HWND_DESKTOP, WA_ERROR);
                    MessageBox(hwnd, MSGBOX_OK, "HTMLedit - Print","Error getting printers info !\nCannot print.");
                    WinDismissDlg(hwnd, FALSE);
                    }

                 WinSendDlgItemMsg(hwnd, DID_PRINTER, LM_DELETEALL, 0L, 0L);
                 for (iCounter = 0; iCounter < iAntal; iCounter++)
                     {
                     if (pPmQueueArray[iCounter].szComment)
                        WinSendDlgItemMsg(hwnd, DID_PRINTER, LM_INSERTITEM, MPFROM2SHORT(LIT_END, 0), pPmQueueArray[iCounter].szComment);
                     else
                        WinSendDlgItemMsg(hwnd, DID_PRINTER, LM_INSERTITEM, MPFROM2SHORT(LIT_END, 0), pPmQueueArray[iCounter].szName);
                     if (pPmQueueArray[iCounter].bDefault == TRUE)
                        iDefault = iCounter;
                     }
                 WinSendDlgItemMsg(hwnd, DID_PRINTER, LM_SELECTITEM, MPFROMSHORT(iDefault), MPFROMSHORT(TRUE));

                 WinSendDlgItemMsg(hwnd, DID_COPIES, SPBM_SETLIMITS, (MPARAM)99, (MPARAM)1);
                 WinSendDlgItemMsg(hwnd, DID_COPIES, SPBM_SETCURRENTVALUE, (MPARAM)1, (MPARAM)NULL);
                 return (0);


            case WM_COMMAND:
                 switch (SHORT1FROMMP(mp1))
                        {
                        case DID_PRINTPROP:
                             iSelected = (int) WinSendDlgItemMsg(hwnd, DID_PRINTER, LM_QUERYSELECTION, NULL, NULL);
                             if (iSelected > -1)
                                PrtQueryJobProperties(app.hab, &(pPmQueueArray[iSelected]));
                             break;

                        case DID_OK:
                             iSelected = (int) WinSendDlgItemMsg(hwnd, DID_PRINTER, LM_QUERYSELECTION, NULL, NULL);
                             if (iSelected > -1)
                                {
                                free(pPmQueueArray);
                                WinSendDlgItemMsg(hwnd, DID_COPIES, SPBM_QUERYVALUE,
                                                  &iCopies, MPFROM2SHORT(0, SPBQ_DONOTUPDATE) );
                                WinDismissDlg(hwnd, iCopies);
                                }
                             break;

                        case DID_CANCEL:
                             free(pPmQueueArray);
                             WinDismissDlg(hwnd, FALSE);
                             break;
                        }
                 break;
            default:
                 return (WinDefDlgProc (hwnd, msg, mp1, mp2));
            }
     return (FALSE);
     }


/*------------------------------------------------------------------------------
   SettingsNoteBookDlgProc: Handles messages for the DLG_SETNOTEBOOK dialog.
-----------------------------------------------------------------------------*/
MRESULT EXPENTRY SettingsNoteBookDlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {
     HWND               hwndNote;
     static HWND        hwndDlg5, hwndDlg4,hwndDlg3, hwndDlg2, hwndDlg1;
     int                id, id2, id3, id4, id5, x, y;
     short              sColor;
     HPS                hps;
     POINTL             aptl[TXTBOX_COUNT];
     char               szStatusText[] = " Items with (*) requires you to restart program.";


     switch (msg)
            {
            case WM_INITDLG:

                 hwndNote = WinWindowFromID(hwnd, DID_SETNOTE);

                 hps = WinGetPS(hwndNote);
                 GpiQueryTextBox(hps, strlen("Colors/Font"), "Colors/Font", TXTBOX_COUNT, aptl);
                 x = max( (aptl[TXTBOX_BOTTOMRIGHT].x - aptl[TXTBOX_BOTTOMLEFT].x) , x);
                 y = max( (aptl[TXTBOX_TOPRIGHT].y - aptl[TXTBOX_BOTTOMRIGHT].y) , y);
                 WinReleasePS(hps);

                 x = x + 10;
                 y = y + 8;
                 WinSendMsg(hwndNote, BKM_SETDIMENSIONS, MPFROM2SHORT(x,y), MPFROMSHORT(BKA_MAJORTAB));

                 hwndDlg5 = WinLoadDlg(hwndNote, hwndNote,
                                      SettingsPage5DlgProc, 0, DLG_NOTE5, NULL);
                 id5 = (int) WinSendMsg(hwndNote, BKM_INSERTPAGE,
                            NULL, MPFROM2SHORT(BKA_AUTOPAGESIZE | BKA_STATUSTEXTON | BKA_MAJOR, BKA_FIRST));
                 WinSendMsg(hwndNote, BKM_SETTABTEXT,
                            (MPARAM)id5, "Viewers");
                 WinSendMsg(hwndNote, BKM_SETSTATUSLINETEXT, (MPARAM)id5, MPFROMP(szStatusText));

                 hwndDlg4 = WinLoadDlg(hwndNote, hwndNote,
                                      SettingsPage4DlgProc, 0, DLG_NOTE4, NULL);
                 id4 = (int) WinSendMsg(hwndNote, BKM_INSERTPAGE,
                            NULL, MPFROM2SHORT(BKA_AUTOPAGESIZE | BKA_STATUSTEXTON | BKA_MAJOR, BKA_FIRST));
                 WinSendMsg(hwndNote, BKM_SETTABTEXT,
                            (MPARAM)id4, "Display");
                 WinSendMsg(hwndNote, BKM_SETSTATUSLINETEXT, (MPARAM)id4, MPFROMP(szStatusText));

                 hwndDlg3 = WinLoadDlg(hwndNote, hwndNote,
                                      SettingsPage3DlgProc, 0, DLG_NOTE1, NULL);
                 id3 = (int) WinSendMsg(hwndNote, BKM_INSERTPAGE,
                            NULL, MPFROM2SHORT(BKA_AUTOPAGESIZE | BKA_STATUSTEXTON | BKA_MAJOR, BKA_FIRST));
                 WinSendMsg(hwndNote, BKM_SETTABTEXT,
                            (MPARAM)id3, "Colors/Font");
                 WinSendMsg(hwndNote, BKM_SETSTATUSLINETEXT, (MPARAM)id3, MPFROMP(szStatusText));

                 hwndDlg2 = WinLoadDlg(hwndNote, hwndNote,
                                      SettingsPage2DlgProc, 0, DLG_NOTE2, NULL);
                 id2 = (int) WinSendMsg(hwndNote, BKM_INSERTPAGE,
                            NULL, MPFROM2SHORT(BKA_AUTOPAGESIZE | BKA_STATUSTEXTON | BKA_MAJOR, BKA_FIRST));
                 WinSendMsg(hwndNote, BKM_SETTABTEXT,
                            (MPARAM)id2, "Addresses");
                 WinSendMsg(hwndNote, BKM_SETSTATUSLINETEXT, (MPARAM)id2, MPFROMP(szStatusText));

                 hwndDlg1 = WinLoadDlg(hwndNote, hwndNote,
                                      SettingsPage1DlgProc, 0, DLG_NOTE3, NULL);
                 id = (int) WinSendMsg(hwndNote, BKM_INSERTPAGE,
                            NULL, MPFROM2SHORT(BKA_AUTOPAGESIZE | BKA_STATUSTEXTON | BKA_MAJOR, BKA_FIRST));
                 WinSendMsg(hwndNote, BKM_SETTABTEXT,
                            (MPARAM)id, "General");
                 WinSendMsg(hwndNote, BKM_SETSTATUSLINETEXT, (MPARAM)id, MPFROMP(szStatusText));

                 WinSendMsg(hwndNote, BKM_SETPAGEWINDOWHWND,
                            MPFROMLONG(id), MPFROMHWND(hwndDlg1));
                 WinSendMsg(hwndNote, BKM_SETPAGEWINDOWHWND,
                            MPFROMLONG(id2), MPFROMHWND(hwndDlg2));
                 WinSendMsg(hwndNote, BKM_SETPAGEWINDOWHWND,
                            MPFROMLONG(id3), MPFROMHWND(hwndDlg3));
                 WinSendMsg(hwndNote, BKM_SETPAGEWINDOWHWND,
                            MPFROMLONG(id4), MPFROMHWND(hwndDlg4));
                 WinSendMsg(hwndNote, BKM_SETPAGEWINDOWHWND,
                            MPFROMLONG(id5), MPFROMHWND(hwndDlg5));

                 WinSendMsg(hwndNote, BKM_TURNTOPAGE,
                            MPFROMLONG(id), NULL);

                 WinShowWindow(hwndDlg1, TRUE);
                 return (0);

            case WM_COMMAND:
                 switch (SHORT1FROMMP(mp1))
                        {
                        case DID_OK:
                             WinDismissDlg(hwnd, TRUE);
                             break;

                        case DID_CANCEL:
                             WinDismissDlg(hwnd, FALSE);
                             break;
                        }
                 break;

            default:
                 return (WinDefDlgProc (hwnd, msg, mp1, mp2));
            }
     return (FALSE);
     }


/*------------------------------------------------------------------------------
   SettingsPage1DlgProc: Handles messages for the DLG_NOTE? dialog.
-----------------------------------------------------------------------------*/
MRESULT EXPENTRY SettingsPage1DlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {

     switch (msg)
            {
            case WM_INITDLG:
                 return (0);


            default:
                 return (WinDefDlgProc (hwnd, msg, mp1, mp2));
            }
     return (FALSE);
     }


/*------------------------------------------------------------------------------
   SettingsPage2DlgProc: Handles messages for the DLG_NOTE? dialog.
-----------------------------------------------------------------------------*/
MRESULT EXPENTRY SettingsPage2DlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {

     switch (msg)
            {
            case WM_INITDLG:
                 return (0);

            default:
                 return (WinDefDlgProc (hwnd, msg, mp1, mp2));
            }
     return (FALSE);
     }


/*------------------------------------------------------------------------------
   SettingsPage3DlgProc: Handles messages for the DLG_NOTE? dialog.
-----------------------------------------------------------------------------*/
MRESULT EXPENTRY SettingsPage3DlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {

     switch (msg)
            {
            case WM_INITDLG:
                 return (0);

            default:
                 return (WinDefDlgProc (hwnd, msg, mp1, mp2));
            }
     return (FALSE);
     }


/*------------------------------------------------------------------------------
   SettingsPage4DlgProc: Handles messages for the DLG_NOTE? dialog.
-----------------------------------------------------------------------------*/
MRESULT EXPENTRY SettingsPage4DlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {

     switch (msg)
            {
            case WM_INITDLG:
                 return (0);

            default:
                 return (WinDefDlgProc (hwnd, msg, mp1, mp2));
            }
     return (FALSE);
     }


/*------------------------------------------------------------------------------
   SettingsPage5DlgProc: Handles messages for the DLG_NOTE? dialog.
-----------------------------------------------------------------------------*/
MRESULT EXPENTRY SettingsPage5DlgProc (HWND hwnd, ULONG msg, MPARAM mp1, MPARAM mp2)
     {

     switch (msg)
            {
            case WM_INITDLG:
                 return (0);

            default:
                 return (WinDefDlgProc (hwnd, msg, mp1, mp2));
            }
     return (FALSE);
     }


/*-----------------------------------------------------------------------------
   KeyGetAscii: Get ascii key pressed.
-----------------------------------------------------------------------------*/
int KeyGetAscii(MPARAM mp1, MPARAM mp2)
     {
     if (SHORT1FROMMP(mp1) & KC_CHAR == 0)
        return (0);

     return(SHORT1FROMMP(mp2));
     }

/*-----------------------------------------------------------------------------
   KeyGetVirtual: Get virtual key pressed.
-----------------------------------------------------------------------------*/
int KeyGetVirtual(MPARAM mp1, MPARAM mp2)
     {
     if (SHORT1FROMMP(mp1) & KC_VIRTUALKEY == 0)
        return (0);

     return(SHORT2FROMMP(mp2));
     }

/*-----------------------------------------------------------------------------
   KeyQueryShift: Query shift state.
-----------------------------------------------------------------------------*/
BOOL KeyQueryShift(int iKey, MPARAM mp1)
     {
     if ( (SHORT1FROMMP(mp1) & iKey) == 0)
        return (FALSE);
     else
        return (TRUE);
     }


/*-----------------------------------------------------------------------------
   MleSetChange: Sets or clears changeflag.
-----------------------------------------------------------------------------*/
void MLESetChange(HWND hwndMLE, BOOL bChange)
     {
     WinSendMsg(hwndMLE, MLM_SETCHANGED, MPFROMSHORT(bChange), NULL);
     }


/*-----------------------------------------------------------------------------
   MleGetChange: Get changeflag.
-----------------------------------------------------------------------------*/
BOOL MLEGetChange(HWND hwndMLE)
     {
     return ((BOOL) WinSendMsg(hwndMLE, MLM_QUERYCHANGED, NULL, NULL));
     }


/*-----------------------------------------------------------------------------
   MLEcursorPos: Where is the cursor (row).
-----------------------------------------------------------------------------*/
int MLECursorRowPos (HWND hwndMLE)
     {
     IPT        iptCurrent;
     int        iCurrentLine;


     iptCurrent = (IPT) WinSendMsg(hwndMLE, MLM_QUERYSEL, MPFROM2SHORT(MLFQS_CURSORSEL, 0), NULL);
     iCurrentLine =  (int) WinSendMsg(hwndMLE, MLM_LINEFROMCHAR, MPFROMLONG(-1), NULL);

     return (iCurrentLine + 1);
     }


/*-----------------------------------------------------------------------------
   MLECursorColPos: Where is the cursor (column).
-----------------------------------------------------------------------------*/
int MLECursorColPos (HWND hwndMLE)
     {
     IPT        iptCurrent, iptFirstOnLine;
     int        iCurrentColumn;


     iptCurrent = (IPT) WinSendMsg(hwndMLE, MLM_QUERYSEL, MPFROM2SHORT(MLFQS_CURSORSEL, 0), NULL);
     iptFirstOnLine =  (IPT) WinSendMsg(hwndMLE, MLM_CHARFROMLINE, MPFROMLONG(-1), NULL);
     iCurrentColumn = iptCurrent - iptFirstOnLine;

     return (iCurrentColumn + 1);
     }


/*------------------------------------------------------------------------------
   SetWXFont: Sets specified font size.
-----------------------------------------------------------------------------*/
void SetWXFont(WXFONTSIZE wxFontSize)
     {
     WXDISPLAYOPTS      wxDispOpts;


     WXViewQueryDisplayOpts(app.hwndWX, &wxDispOpts, sizeof(WXDISPLAYOPTS));
     wxDispOpts.wxFontSize = wxFontSize;
     WXViewSetDisplayOpts(app.hwndWX, &wxDispOpts, sizeof(WXDISPLAYOPTS));
     }

