/********************************************************************/
/*  Include file for HTMedit                                        */
/********************************************************************/

/* some constants */
#define ID_STATUS1               1101
#define ID_STATUS2               1102
#define ID_WXWIN                 1103
#define ID_MLE                   1105


/* recource constants */
#define ID_RESOURCE              256
#define ID_ICON                  ID_RESOURCE

#define IDB_0                    100
#define IDB_1                    101
#define IDB_2                    102
#define IDB_3                    103
#define IDB_4                    104
#define IDB_5                    105
#define IDB_6                    106
#define IDB_7                    107
#define IDB_8                    108
#define IDB_9                    109
#define IDB_10                   110
#define IDB_11                   111


/* menu constants */
#define IDM_FILE                 1010
#define IDM_NEW                  1011
#define IDM_LOAD                 1012
#define IDM_SAVE                 1013
#define IDM_SAVEAS               1014
#define IDM_PRINT                1015

#define IDM_EDIT                 2000
#define IDM_UNDO                 2001
#define IDM_CUT                  2010
#define IDM_COPY                 2011
#define IDM_PASTE                2012
#define IDM_CLEAR                2020
#define IDM_SELALL               2030
#define IDM_FIND                 2040
#define IDM_UPDATE               2050
#define IDM_MAXTEXT              2060
#define IDM_EQUAL                2062
#define IDM_MAXHTML              2064

#define IDM_TAGS                 3000
#define IDM_SKELETON             3001
#define IDM_HTML                 3010
#define IDM_HEAD                 3011
#define IDM_BODY                 3012
#define IDM_CENTER               3020
#define IDM_HORZRULER            3021
#define IDM_REFERENCE            3022
#define IDM_IMAGE                3023
#define IDM_COMMENT              3024

#define IDM_STYLES               4000
#define IDM_BOLD                 4010
#define IDM_ITALIC               4011
#define IDM_U                    4012
#define IDM_BIG                  4020
#define IDM_SMALL                4021
#define IDM_SUP                  4025
#define IDM_SUB                  4026
#define IDM_STRONG               4030
#define IDM_EM                   4031
#define IDM_STRIKE               4032
#define IDM_CITE                 4033
#define IDM_TT                   4040
#define IDM_BLOCKQUOTE           4041
#define IDM_PRE                  4045
#define IDM_VAR                  4046
#define IDM_SAMP                 4047
#define IDM_KBD                  4048
#define IDM_CODE                 4049
#define IDM_HEADING              4060
#define IDM_H1                   4061
#define IDM_H2                   4062
#define IDM_H3                   4063
#define IDM_H4                   4064
#define IDM_H5                   4065
#define IDM_H6                   4066

#define IDM_OPTIONS              5000
#define IDM_FONTSIZE             5010
#define IDM_SAVESET              5050

#define IDM_HELP                 9000
#define IDM_HELPINDEX            9001
#define IDM_HELPGENERAL          9002
#define IDM_HELPUSING            9003
#define IDM_HELPKEYS             9004
#define IDM_ABOUT                9010


typedef struct _SETTINGS
        {
        SWP             swp;
        int             iSplitPos;

        char            szLoadFrom[256];
        char            szSaveTo[256];

        char            szMLEFontSize[64+1];
        int             iMLEForeColor;
        int             iMLEBackColor;

        } SETTINGS;


typedef struct _APPLICATION
        {
        HAB             hab;
        HWND            hwndFrame;
        HWND            hwndClient;
        HWND            hwndStatus;
        HWND            hwndButtonBar;
        HWND            hwndWX;
        HWND            hwndMLE;
        HWND            hwndSplitCanvas;

        STBTNBAR        bb;
        SPLITBAR        sb;
        STSTATUSBAR     stsb;

        char            szIniFile[_MAX_PATH];

        char            szFile[_MAX_PATH];
        char            szName[_MAX_PATH];
        BOOL            bNamed;
        BOOL            bChanged;

        int             iSplitSetting;

        int		iwxFontSize;

        SETTINGS        set;
        } APPLICATION;
